defmodule Permutations do
  def index_at(_, 0), do: []
  def index_at(n, remaining) do
    blk_size = Euler.Algebra.fact(remaining - 1)
    [ div(n, blk_size) | index_at(rem(n, blk_size), remaining - 1) ]
  end

  def translate(a, n) when is_number(n), do: translate(a, (0..(n-1)) |> Enum.to_list)
  def translate(_, []), do: []
  def translate([next | rest], allowed) do
    [ (allowed |> Enum.at(next)) | translate(rest, allowed |> List.delete_at(next)) ]
  end
end

# subtract one to get the 1 millionth permutation (bc it's zero indexed
 Permutations.index_at(1_000_000 - 1, 10)
 |> Permutations.translate(0..9 |> Enum.to_list)
 |> Enum.join("")
 |> IO.puts()
